#include	"ppc403ga.h"

#ifdef	_DEBUG
#include	<stdio.h>
#include	"../../window/console/console.h"

extern		CONSOLE		con;
#endif



unsigned long	PPC403GA::dcr_r(unsigned long DCRN)
{
#ifdef	_DEBUG
	char			buf[0x1000];

	CO("DCR ");
	switch(DCRN){
		case	0x40:	sprintf(buf,"EXISR > %08X\n",r[DCR_EXISR]);		break;
		case	0x42:	sprintf(buf,"EXIER > %08X\n",r[DCR_EXIER]);		break;
		case	0x80:	sprintf(buf,"BR0 > %08X\n",r[DCR_BR0]);			break;
		case	0x81:	sprintf(buf,"BR1 > %08X\n",r[DCR_BR1]);			break;
		case	0x82:	sprintf(buf,"BR2 > %08X\n",r[DCR_BR2]);			break;
		case	0x83:	sprintf(buf,"BR3 > %08X\n",r[DCR_BR3]);			break;
		case	0x84:	sprintf(buf,"BR4 > %08X\n",r[DCR_BR4]);			break;
		case	0x85:	sprintf(buf,"BR5 > %08X\n",r[DCR_BR5]);			break;
		case	0x86:	sprintf(buf,"BR6 > %08X\n",r[DCR_BR6]);			break;
		case	0x87:	sprintf(buf,"BR7 > %08X\n",r[DCR_BR7]);			break;
		case	0x90:	sprintf(buf,"BEAR > %08X\n",r[DCR_BEAR]);		break;
		case	0x91:	sprintf(buf,"BESR > %08X\n",r[DCR_BESR]);		break;
		case	0xa0:	sprintf(buf,"IOCR > %08X\n",r[DCR_IOCR]);		break;
		case	0xc0:	sprintf(buf,"DMACR0 > %08X\n",r[DCR_DMACR0]);	break;
		case	0xc1:	sprintf(buf,"DMACT0 > %08X\n",r[DCR_DMACT0]);	break;
		case	0xc2:	sprintf(buf,"DMADA0 > %08X\n",r[DCR_DMADA0]);	break;
		case	0xc3:	sprintf(buf,"DMASA0 > %08X\n",r[DCR_DMASA0]);	break;
		case	0xc4:	sprintf(buf,"DMACC0 > %08X\n",r[DCR_DMACC0]);	break;
		case	0xc8:	sprintf(buf,"DMACR1 > %08X\n",r[DCR_DMACR1]);	break;
		case	0xc9:	sprintf(buf,"DMACT1 > %08X\n",r[DCR_DMACT1]);	break;
		case	0xca:	sprintf(buf,"DMADA1 > %08X\n",r[DCR_DMADA1]);	break;
		case	0xcb:	sprintf(buf,"DMASA1 > %08X\n",r[DCR_DMASA1]);	break;
		case	0xcc:	sprintf(buf,"DMACC1 > %08X\n",r[DCR_DMACC1]);	break;
		case	0xd0:	sprintf(buf,"DMACR2 > %08X\n",r[DCR_DMACR2]);	break;
		case	0xd1:	sprintf(buf,"DMACT2 > %08X\n",r[DCR_DMACT2]);	break;
		case	0xd2:	sprintf(buf,"DMADA2 > %08X\n",r[DCR_DMADA2]);	break;
		case	0xd3:	sprintf(buf,"DMASA2 > %08X\n",r[DCR_DMASA2]);	break;
		case	0xd4:	sprintf(buf,"DMACC2 > %08X\n",r[DCR_DMACC2]);	break;
		case	0xd8:	sprintf(buf,"DMACR3 > %08X\n",r[DCR_DMACR3]);	break;
		case	0xd9:	sprintf(buf,"DMACT3 > %08X\n",r[DCR_DMACT3]);	break;
		case	0xda:	sprintf(buf,"DMADA3 > %08X\n",r[DCR_DMADA3]);	break;
		case	0xdb:	sprintf(buf,"DMASA3 > %08X\n",r[DCR_DMASA3]);	break;
		case	0xdc:	sprintf(buf,"DMACC3 > %08X\n",r[DCR_DMACC3]);	break;
		case	0xe0:	sprintf(buf,"DMASR > %08X\n",r[DCR_DMASR]);		break;
	}
	CO(buf);
#endif

	switch(DCRN){
		case	0x40:	return(r[DCR_EXISR]);
		case	0x42:	return(r[DCR_EXIER]);
		case	0x80:	return(r[DCR_BR0]);
		case	0x81:	return(r[DCR_BR1]);
		case	0x82:	return(r[DCR_BR2]);
		case	0x83:	return(r[DCR_BR3]);
		case	0x84:	return(r[DCR_BR4]);
		case	0x85:	return(r[DCR_BR5]);
		case	0x86:	return(r[DCR_BR6]);
		case	0x87:	return(r[DCR_BR7]);
		case	0x90:	return(r[DCR_BEAR]);
		case	0x91:	return(r[DCR_BESR]);
		case	0xa0:	return(r[DCR_IOCR]);
		case	0xc0:	return(r[DCR_DMACR0]);
		case	0xc1:	return(r[DCR_DMACT0]);
		case	0xc2:	return(r[DCR_DMADA0]);
		case	0xc3:	return(r[DCR_DMASA0]);
		case	0xc4:	return(r[DCR_DMACC0]);
		case	0xc8:	return(r[DCR_DMACR1]);
		case	0xc9:	return(r[DCR_DMACT1]);
		case	0xca:	return(r[DCR_DMADA1]);
		case	0xcb:	return(r[DCR_DMASA1]);
		case	0xcc:	return(r[DCR_DMACC1]);
		case	0xd0:	return(r[DCR_DMACR2]);
		case	0xd1:	return(r[DCR_DMACT2]);
		case	0xd2:	return(r[DCR_DMADA2]);
		case	0xd3:	return(r[DCR_DMASA2]);
		case	0xd4:	return(r[DCR_DMACC2]);
		case	0xd8:	return(r[DCR_DMACR3]);
		case	0xd9:	return(r[DCR_DMACT3]);
		case	0xda:	return(r[DCR_DMADA3]);
		case	0xdb:	return(r[DCR_DMASA3]);
		case	0xdc:	return(r[DCR_DMACC3]);
		case	0xe0:	return(r[DCR_DMASR]);
	}

#ifdef	_DEBUG
	sprintf(buf,"invalid DCR number addr=%08X code=%08X\n",r[PC],r4(r[PC]));
	CO(buf);
#endif
	return(0xffffffff);
}



void	PPC403GA::dcr_w(unsigned long DCRN,unsigned long data)
{
#ifdef	_DEBUG
	char			buf[0x1000];

	CO("DCR ");
	switch(DCRN){
		case	0x40:	CO("EXISR");	break;
		case	0x42:	CO("EXIER");	break;
		case	0x90:	CO("BEAR");		break;
		case	0x91:	CO("BESR");		break;
		case	0xa0:	CO("IOCR");		break;
		case	0xc0:	CO("DMACR0");	break;
		case	0xc1:	CO("DMACT0");	break;
		case	0xc2:	CO("DMADA0");	break;
		case	0xc3:	CO("DMASA0");	break;
		case	0xc4:	CO("DMACC0");	break;
		case	0xc8:	CO("DMACR1");	break;
		case	0xc9:	CO("DMACT1");	break;
		case	0xca:	CO("DMADA1");	break;
		case	0xcb:	CO("DMASA1");	break;
		case	0xcc:	CO("DMACC1");	break;
		case	0xd0:	CO("DMACR2");	break;
		case	0xd1:	CO("DMACT2");	break;
		case	0xd2:	CO("DMADA2");	break;
		case	0xd3:	CO("DMASA2");	break;
		case	0xd4:	CO("DMACC2");	break;
		case	0xd8:	CO("DMACR3");	break;
		case	0xd9:	CO("DMACT3");	break;
		case	0xda:	CO("DMADA3");	break;
		case	0xdb:	CO("DMASA3");	break;
		case	0xdc:	CO("DMACC3");	break;
		case	0xe0:	CO("DMASR");	break;
	}
	sprintf(buf," < %08X\n",data);	CO(buf);
#endif

	switch(DCRN){
		case	0x40:	r[DCR_EXISR]&=data;	return;
		case	0x42:	r[DCR_EXIER]=data;	return;

		case	0x80:	case	0x81:	case	0x82:	case	0x83:
		case	0x84:	case	0x85:	case	0x86:	case	0x87:
			r[DCR_BR0+(DCRN&7)]=data;
#ifdef	_DEBUG
			sprintf(buf,"Bank %d(",DCRN&7);	CO(buf);
			if(data&0x00000001)	CO("type SRAM : ");
				else			CO("type DRAM : ");
			sprintf(buf,"addr %02X : ",data>>24);	CO(buf);
			sprintf(buf,"size %02dMB : ",1<<((data>>21)&7));	CO(buf);
			switch(data&0x00180000){
				case	0x00000000:	CO("usage -- : ");	break;
				case	0x00080000:	CO("usage R- : ");	break;
				case	0x00100000:	CO("usage -W : ");	break;
				case	0x00180000:	CO("usage RW : ");	break;	}
			switch(data&0x00018000){
				case	0x00000000:	CO("width  8bit)\n");	break;
				case	0x00008000:	CO("width 16bit)\n");	break;
				case	0x00010000:	CO("width 32bit)\n");	break;
				case	0x00018000:	CO("width --bit)\n");	break;	}
#endif
			return;

		case	0x90:	r[DCR_BEAR]=data;	return;
		case	0x91:	r[DCR_BESR]=data;	return;

		case	0xa0:	r[DCR_IOCR]=data;	return;

		case	0xc0:	r[DCR_DMACR0]=data;	return;
		case	0xc1:	r[DCR_DMACT0]=data;	return;
		case	0xc2:	r[DCR_DMADA0]=data;	return;
		case	0xc3:	r[DCR_DMASA0]=data;	return;
		case	0xc4:	r[DCR_DMACC0]=data;	return;

		case	0xc8:	r[DCR_DMACR1]=data;	return;
		case	0xc9:	r[DCR_DMACT1]=data;	return;
		case	0xca:	r[DCR_DMADA1]=data;	return;
		case	0xcb:	r[DCR_DMASA1]=data;	return;
		case	0xcc:	r[DCR_DMACC1]=data;	return;

		case	0xd0:	r[DCR_DMACR2]=data;	return;
		case	0xd1:	r[DCR_DMACT2]=data;	return;
		case	0xd2:	r[DCR_DMADA2]=data;	return;
		case	0xd3:	r[DCR_DMASA2]=data;	return;
		case	0xd4:	r[DCR_DMACC2]=data;	return;

		case	0xd8:	r[DCR_DMACR3]=data;	return;
		case	0xd9:	r[DCR_DMACT3]=data;	return;
		case	0xda:	r[DCR_DMADA3]=data;	return;
		case	0xdb:	r[DCR_DMASA3]=data;	return;
		case	0xdc:	r[DCR_DMACC3]=data;	return;

		case	0xe0:	r[DCR_DMASR]&=data;	return;
	}

#ifdef	_DEBUG
	sprintf(buf,"invalid DCR number addr=%08X code=%08X\n",r[PC],r4(r[PC]));
	CO(buf);
#endif
}
