#include	<windows.h>
#include	"io.h"
#include	"../../window/main/main.h"
#include	"../../window/gfx/gfx.h"
#include	"../../cpu/ppc403ga/ppc403ga.h"

#ifdef	_DEBUG
#include	<stdio.h>
#include	"../../window/console/console.h"

extern	CONSOLE	con;
#endif	_DEBUG
extern	PPC403GA	ppc;
extern	GFX			gfx;
extern	HWND		hWnd_main;



unsigned char	IO::_r1(unsigned char *dmy,unsigned long addr)
{
#ifdef	_DEBUG
	char	buf[0x100];
	sprintf(buf,"<IO>\tR1\t%08X\n",addr);	CO(buf);
#endif
	return(reg[addr]);
}



unsigned short	IO::_r2(unsigned char *dmy,unsigned long addr)
{
#ifdef	_DEBUG
	char	buf[0x100];
	sprintf(buf,"<IO>\tR2\t%08X\n",addr);	CO(buf);
#endif
	return(0xffff);
}



unsigned long	IO::_r4(unsigned char *dmy,unsigned long addr)
{
	addr=(addr&0xffff)>>2;

#ifdef	_DEBUG
	char	buf[0x100];
	sprintf(buf,"<IO>\tR4\t%08X\n",addr);	CO(buf);
#endif
	return(0xffffffff);
}





void	IO::_w1(unsigned char *dmy,unsigned long addr,unsigned char data)
{
#ifdef	_DEBUG
	char	buf[0x100];
#endif

	switch(addr){
		case	0x10000:
			reg[IO_SREG_W+0]=data;
#ifdef	_DEBUG
	sprintf(buf,"<7SEG>\t < %04X\n",data);	CO(buf);
#endif
			if((gfx.vinfo_stat&0x000000ff)==0x00000001){
					gfx.make_vinfo();
					gfx.make_vdraw();
					gfx.vd2wd();
					SendMessage(hWnd_main,WM_PAINT,NULL,NULL);	}
			return;
		case	0x10001:
			reg[IO_SREG_W+1]=data;
#ifdef	_DEBUG
	sprintf(buf,"<7SEG>\t < %04X\n",data);	CO(buf);
#endif
			if((gfx.vinfo_stat&0x000000ff)==0x00000001){
					gfx.make_vinfo();
					gfx.make_vdraw();
					gfx.vd2wd();
					SendMessage(hWnd_main,WM_PAINT,NULL,NULL);	}
			return;
		case	0x10006:
			if(		((reg[IO_SREG_W+6]	&0x80)==0x00)	&&
					((data				&0x80)==0x80)		){
				ppc.r[SPR_TSR]|=0x40000000;	
				ppc.r[SPR_TBHI]=0;	
				ppc.r[SPR_TBLO]=0;								}
			reg[IO_SREG_W+6]=data;
			return;
		default:
#ifdef	_DEBUG
	sprintf(buf,"<IO>\tW1\t%08X < %02X\n",addr,data);	CO(buf);
#endif
			reg[IO_SREG_W+addr]=data;
			return;
	}
}




void	IO::_w2(unsigned char *dmy,unsigned long addr,unsigned short data)
{
#ifdef	_DEBUG
	char	buf[0x100];
#endif

	switch(addr){
		case	0x10000:
#ifdef	_DEBUG
	sprintf(buf,"<7SEG>\t < %04X\n",data);	CO(buf);
#endif
			reg[IO_SREG_W+0]=(unsigned char)(data>>8);
			reg[IO_SREG_W+1]=(unsigned char)data;
			if((gfx.vinfo_stat&0x000000ff)==0x00000001){
					gfx.make_vinfo();
					gfx.make_vdraw();
					gfx.vd2wd();
					SendMessage(hWnd_main,WM_PAINT,NULL,NULL);	}
			return;
	}

#ifdef	_DEBUG
	sprintf(buf,"<IO>\tW2\t%08X < %04X\n",addr,data);	CO(buf);
#endif
}




void	IO::_w4(unsigned char *dmy,unsigned long addr,unsigned long data)
{
#ifdef	_DEBUG
	char	buf[0x100];
	sprintf(buf,"<IO>\tW4\t%02X < %08X\n",addr,data);	CO(buf);
#endif
}
