#ifndef		_AZU_WINDOW_CPUID_
#define		_AZU_WINDOW_CPUID_

#include	<windows.h>

//	Standard Feature Support
#define	_CPUID_SFS_			0x00000001
#define	_CPUID_SFS_FPU_		0x00000001
#define	_CPUID_SFS_VME_		0x00000002
#define	_CPUID_SFS_DE_		0x00000004
#define	_CPUID_SFS_PSE_		0x00000008
#define	_CPUID_SFS_TSC_		0x00000010
#define	_CPUID_SFS_MSR_		0x00000020
#define	_CPUID_SFS_PAE_		0x00000040
#define	_CPUID_SFS_MCE_		0x00000080
#define	_CPUID_SFS_CX8_		0x00000100
#define	_CPUID_SFS_APIC_	0x00000200
#define	_CPUID_SFS_R10_		0x00000400
#define	_CPUID_SFS_SEP_		0x00000800
#define	_CPUID_SFS_MTRR_	0x00001000
#define	_CPUID_SFS_PGE_		0x00002000
#define	_CPUID_SFS_MCA_		0x00004000
#define	_CPUID_SFS_CMOV_	0x00008000
#define	_CPUID_SFS_PAT_		0x00010000
#define	_CPUID_SFS_PSE36_	0x00020000
#define	_CPUID_SFS_PN_		0x00040000
#define	_CPUID_SFS_CLF_		0x00080000
#define	_CPUID_SFS_R20_		0x00100000
#define	_CPUID_SFS_R21_		0x00200000
#define	_CPUID_SFS_R22_		0x00400000
#define	_CPUID_SFS_MMX_		0x00800000
#define	_CPUID_SFS_FXSR_	0x01000000
#define	_CPUID_SFS_XMM_		0x02000000
#define	_CPUID_SFS_SSE2_	0x04000000
#define	_CPUID_SFS_R27_		0x08000000
#define	_CPUID_SFS_R28_		0x10000000
#define	_CPUID_SFS_R29_		0x20000000
#define	_CPUID_SFS_R30_		0x40000000
#define	_CPUID_SFS_R31_		0x80000000

//	AMD Feature Support
#define	_CPUID_AFS_			0x80000001
#define	_CPUID_AFS_FPU_		0x00000001
#define	_CPUID_AFS_VME_		0x00000002
#define	_CPUID_AFS_DE_		0x00000004
#define	_CPUID_AFS_PSE_		0x00000008
#define	_CPUID_AFS_TSC_		0x00000010
#define	_CPUID_AFS_MSR_		0x00000020
#define	_CPUID_AFS_PAE_		0x00000040
#define	_CPUID_AFS_MCE_		0x00000080
#define	_CPUID_AFS_CX8_		0x00000100
#define	_CPUID_AFS_APIC_	0x00000200
#define	_CPUID_AFS_R10_		0x00000400
#define	_CPUID_AFS_SEP_		0x00000800
#define	_CPUID_AFS_MTRR_	0x00001000
#define	_CPUID_AFS_PGE_		0x00002000
#define	_CPUID_AFS_MCA_		0x00004000
#define	_CPUID_AFS_CMOV_	0x00008000
#define	_CPUID_AFS_PAT_		0x00010000
#define	_CPUID_AFS_PSE36_	0x00020000	//
#define	_CPUID_AFS_R18_		0x00040000
#define	_CPUID_AFS_R19_		0x00080000
#define	_CPUID_AFS_NX_		0x00100000
#define	_CPUID_AFS_R21_		0x00200000
#define	_CPUID_AFS_EMMX_	0x00400000
#define	_CPUID_AFS_MMX_		0x00800000
#define	_CPUID_AFS_FXSR_	0x01000000
#define	_CPUID_AFS_FFXSR_	0x02000000
#define	_CPUID_AFS_R26_		0x04000000
#define	_CPUID_AFS_R27_		0x08000000
#define	_CPUID_AFS_R28_		0x10000000
#define	_CPUID_AFS_LM_		0x20000000
#define	_CPUID_AFS_E3DN_	0x40000000
#define	_CPUID_AFS_3DN_		0x80000000

//	Advanced Power Management Features
#define	_CPUID_APMF_		0x80000007
#define	_CPUID_APMF_TS_		0x00000001
#define	_CPUID_APMF_FID_	0x00000002
#define	_CPUID_APMF_VID_	0x00000004
#define	_CPUID_APMF_TTP_	0x00000008
#define	_CPUID_APMF_TM_		0x00000010
#define	_CPUID_APMF_STC_	0x00000020
#define	_CPUID_APMF_R06_	0x00000040
#define	_CPUID_APMF_R07_	0x00000080
#define	_CPUID_APMF_R08_	0x00000100
#define	_CPUID_APMF_R09_	0x00000200
#define	_CPUID_APMF_R10_	0x00000400
#define	_CPUID_APMF_R11_	0x00000800
#define	_CPUID_APMF_R12_	0x00001000
#define	_CPUID_APMF_R13_	0x00002000
#define	_CPUID_APMF_R14_	0x00004000
#define	_CPUID_APMF_R15_	0x00008000
#define	_CPUID_APMF_R16_	0x00010000
#define	_CPUID_APMF_R17_	0x00020000
#define	_CPUID_APMF_R18_	0x00040000
#define	_CPUID_APMF_R19_	0x00080000
#define	_CPUID_APMF_R20_	0x00100000
#define	_CPUID_APMF_R21_	0x00200000
#define	_CPUID_APMF_R22_	0x00400000
#define	_CPUID_APMF_R23_	0x00800000
#define	_CPUID_APMF_R24_	0x01000000
#define	_CPUID_APMF_R25_	0x02000000
#define	_CPUID_APMF_R26_	0x04000000
#define	_CPUID_APMF_R27_	0x08000000
#define	_CPUID_APMF_R28_	0x10000000
#define	_CPUID_APMF_R29_	0x20000000
#define	_CPUID_APMF_R30_	0x40000000
#define	_CPUID_APMF_R31_	0x80000000



class	CPUID{
		void			_cpuid(unsigned long *,unsigned long);
public:
		unsigned long	standard_max;
		unsigned long	amd_max;
		unsigned long	*standard;
		unsigned long	*amd;
		CPUID();
};

#endif		_AZU_WINDOW_CPUID_
