#include	<windows.h>
#include	<stdio.h>
#include	"../device/device.h"
#include	"../device/memory/memory.h"
#include	"../pkzip/pkzip.h"

		PKZIP				pkzip;
extern	HWND				hWnd_main;
extern	char				path_inifile[_MAX_PATH];

extern	MEMORY				rom_p1;
extern	MEMORY				rom_p2;
extern	MEMORY				rom_p3;
extern	MEMORY				rom_c1;
extern	MEMORY				rom_c2;
extern	MEMORY				ram_s1;

void	load_rom(void);
void	load_rom_gradius4(void);



void	load_rom(void)
{
	unsigned long	game=GetPrivateProfileInt("system","game",0,path_inifile);

	switch(game){
		default:
		case	0:	load_rom_gradius4();		break;
//		case	1:	load_rom_silent_scope();	break;
//		case	2:	load_rom_racing_jam();		break;
	}
}



void	load_rom_gradius4(void)
{
	HANDLE			h_zip;
	unsigned char	*b_zip=NULL;
	unsigned long	s_zip;
	unsigned long	tul1;
	char			rp[_MAX_PATH];
	char			tf[_MAX_PATH];
	unsigned char	*swp1=NULL;
	unsigned char	*swp2=NULL;

	swp1	=new unsigned char[0x00400000];
	swp2	=new unsigned char[0x00400000];

	GetPrivateProfileString("system","rompath","",rp,_MAX_PATH,path_inifile);

	sprintf(tf,"%s\\gradius4.zip",rp);
	h_zip=CreateFile(tf,GENERIC_READ,0,0,OPEN_EXISTING,0,0);
	if(h_zip==(void *)-1){	MessageBox(hWnd_main,"gradius4.zip not found",
		"ERROR",MB_OK|MB_SYSTEMMODAL);
					CloseHandle(h_zip);	goto	routine_end;	}
	s_zip	=GetFileSize(h_zip,NULL);
	b_zip	=new unsigned char[s_zip];
	ReadFile(h_zip,b_zip,s_zip,&tul1,NULL);
	CloseHandle(h_zip);



	tul1=pkzip.m_search_name(b_zip,s_zip,"837A10.14P");
	if(tul1==0xffffffff){	MessageBox(hWnd_main,"837A10.14P not found",
		"ERROR",MB_OK|MB_SYSTEMMODAL);	goto	routine_end;	}
	tul1=pkzip.m_extract(						b_zip+tul1+ZNAM+
							*(unsigned short *)(b_zip+tul1+ZFLN)+
							*(unsigned short *)(b_zip+tul1+ZXLN),
							*(unsigned long  *)(b_zip+tul1+ZZLN),
							swp1,0x00400000							);

	tul1=pkzip.m_search_name(b_zip,s_zip,"837A09.16P");
	if(tul1==0xffffffff){	MessageBox(hWnd_main,"837A09.16P not found",
		"ERROR",MB_OK|MB_SYSTEMMODAL);	goto	routine_end;	}
	tul1=pkzip.m_extract(						b_zip+tul1+ZNAM+
							*(unsigned short *)(b_zip+tul1+ZFLN)+
							*(unsigned short *)(b_zip+tul1+ZXLN),
							*(unsigned long  *)(b_zip+tul1+ZZLN),
							swp2,0x00400000							);

	for(tul1=0;tul1<0x00400000;tul1++){	*(rom_p2.mem+tul1*2  )=swp1[tul1];
										*(rom_p2.mem+tul1*2+1)=swp2[tul1];	}



	tul1=pkzip.m_search_name(b_zip,s_zip,"837A05.14T");
	if(tul1==0xffffffff){	MessageBox(hWnd_main,"837A05.14T not found",
		"ERROR",MB_OK|MB_SYSTEMMODAL);	goto	routine_end;	}
	tul1=pkzip.m_extract(						b_zip+tul1+ZNAM+
							*(unsigned short *)(b_zip+tul1+ZFLN)+
							*(unsigned short *)(b_zip+tul1+ZXLN),
							*(unsigned long  *)(b_zip+tul1+ZZLN),
							swp1,0x00400000							);

	tul1=pkzip.m_search_name(b_zip,s_zip,"837A04.16T");
	if(tul1==0xffffffff){	MessageBox(hWnd_main,"837A04.16T not found",
		"ERROR",MB_OK|MB_SYSTEMMODAL);	goto	routine_end;	}
	tul1=pkzip.m_extract(						b_zip+tul1+ZNAM+
							*(unsigned short *)(b_zip+tul1+ZFLN)+
							*(unsigned short *)(b_zip+tul1+ZXLN),
							*(unsigned long  *)(b_zip+tul1+ZZLN),
							swp2,0x00400000							);

	for(tul1=0;tul1<0x00400000;tul1++){	*(rom_p3.mem+tul1*2  )=swp1[tul1];
										*(rom_p3.mem+tul1*2+1)=swp2[tul1];	}



	tul1=pkzip.m_search_name(b_zip,s_zip,"837A14.32U");
	if(tul1==0xffffffff){	MessageBox(hWnd_main,"837A14.32U not found",
		"ERROR",MB_OK|MB_SYSTEMMODAL);	goto	routine_end;	}
	tul1=pkzip.m_extract(						b_zip+tul1+ZNAM+
							*(unsigned short *)(b_zip+tul1+ZFLN)+
							*(unsigned short *)(b_zip+tul1+ZXLN),
							*(unsigned long  *)(b_zip+tul1+ZZLN),
							swp1,0x00400000							);

	tul1=pkzip.m_search_name(b_zip,s_zip,"837A13.24U");
	if(tul1==0xffffffff){	MessageBox(hWnd_main,"837A13.24U not found",
		"ERROR",MB_OK|MB_SYSTEMMODAL);	goto	routine_end;	}
	tul1=pkzip.m_extract(						b_zip+tul1+ZNAM+
							*(unsigned short *)(b_zip+tul1+ZFLN)+
							*(unsigned short *)(b_zip+tul1+ZXLN),
							*(unsigned long  *)(b_zip+tul1+ZZLN),
							swp2,0x00400000							);

	for(tul1=0;tul1<0x00400000;tul1++){	*(rom_c1.mem+tul1*2  )=swp1[tul1];
										*(rom_c1.mem+tul1*2+1)=swp2[tul1];	}



	tul1=pkzip.m_search_name(b_zip,s_zip,"837A16.32V");
	if(tul1==0xffffffff){	MessageBox(hWnd_main,"837A16.32V not found",
		"ERROR",MB_OK|MB_SYSTEMMODAL);	goto	routine_end;	}
	tul1=pkzip.m_extract(						b_zip+tul1+ZNAM+
							*(unsigned short *)(b_zip+tul1+ZFLN)+
							*(unsigned short *)(b_zip+tul1+ZXLN),
							*(unsigned long  *)(b_zip+tul1+ZZLN),
							swp1,0x00400000							);

	tul1=pkzip.m_search_name(b_zip,s_zip,"837A15.24V");
	if(tul1==0xffffffff){	MessageBox(hWnd_main,"837A15.24V not found",
		"ERROR",MB_OK|MB_SYSTEMMODAL);	goto	routine_end;	}
	tul1=pkzip.m_extract(						b_zip+tul1+ZNAM+
							*(unsigned short *)(b_zip+tul1+ZFLN)+
							*(unsigned short *)(b_zip+tul1+ZXLN),
							*(unsigned long  *)(b_zip+tul1+ZZLN),
							swp2,0x00400000							);

	for(tul1=0;tul1<0x00400000;tul1++){	*(rom_c2.mem+tul1*2  )=swp1[tul1];
										*(rom_c2.mem+tul1*2+1)=swp2[tul1];	}



	tul1=pkzip.m_search_name(b_zip,s_zip,"837C01.27P");
	if(tul1==0xffffffff){	MessageBox(hWnd_main,"837C05.27P not found",
		"ERROR",MB_OK|MB_SYSTEMMODAL);	goto	routine_end;	}
	tul1=pkzip.m_extract(						b_zip+tul1+ZNAM+
							*(unsigned short *)(b_zip+tul1+ZFLN)+
							*(unsigned short *)(b_zip+tul1+ZXLN),
							*(unsigned long  *)(b_zip+tul1+ZZLN),
							swp1,0x00200000							);

	for(tul1=0;tul1<0x200000;tul1+=2){	*(rom_p1.mem+tul1+0)=swp1[tul1+1];
										*(rom_p1.mem+tul1+1)=swp1[tul1+0];	}



	tul1=pkzip.m_search_name(b_zip,s_zip,"837A08.7S");
	if(tul1==0xffffffff){	MessageBox(hWnd_main,"837_A08.7S not found",
		"ERROR",MB_OK|MB_SYSTEMMODAL);	goto	routine_end;	}
	tul1=pkzip.m_extract(						b_zip+tul1+ZNAM+
							*(unsigned short *)(b_zip+tul1+ZFLN)+
							*(unsigned short *)(b_zip+tul1+ZXLN),
							*(unsigned long  *)(b_zip+tul1+ZZLN),
							swp1,0x00080000							);

	for(tul1=0;tul1<0x080000;tul1+=2){	*(ram_s1.mem+tul1  )=swp1[tul1+1];
										*(ram_s1.mem+tul1+1)=swp1[tul1  ];	}

routine_end:
	if(b_zip!=NULL)		delete[]	b_zip;
	if(swp1!=NULL)		delete[]	swp1;
	if(swp2!=NULL)		delete[]	swp2;
}
