#include	<windows.h>
#include	"../cpu/mc68k/mc68k.h"
#include	"../cpu/ppc403ga/ppc403ga.h"
#include	"../device/memory/memory.h"
#include	"../device/io/io.h"
#include	"../device/kbg/kbg.h"
#include	"../device/ignore/ignore.h"

		MEMORY				rom_p1(0x00200000,0);
		MEMORY				rom_p2(0x00800000,0);
		MEMORY				rom_p3(0x00800000,0);
		MEMORY				ram_s1(0x00080000,0);
		MEMORY				ram_s2(0x00010000,0);
		MEMORY				ram_s3(0x00010000,0);
		MEMORY				rom_c1(0x00800000,0);
		MEMORY				rom_c2(0x00800000,0);
		MEMORY				ram_b4(0x00400000,0);
		MEMORY				ram_d1(0x00060000,0);
		MEMORY				ram_d2(0x00010000,0);

		PPC403GA			ppc;
		MC68K				m68k;

		IO					io;
		KBG					kbg;
		IGN					ign;

		void				mem_bind(void);
		void				mem_unbind(void);



void	mem_bind(void)
{
	unsigned long	x,z;

/******************************************************************************
	PowerPC 403 GA
******************************************************************************/

	for(x=1;x!=0x10000;x++)		ppc.mat[x].type=NULL;

#ifdef	DYNAMIC_RECOMPILE
	ppc.bind(0x0000,0x80,MAT_ROM,   0x0000ffff,&rom_p2,rom_p2.mem,rom_p2.drc);
	ppc.bind(0x0080,0x80,MAT_ROM,   0x0000ffff,&rom_p3,rom_p3.mem,rom_p3.drc);
	ppc.bind(0x0100,0x80,MAT_ROM,   0x0000ffff,&rom_c1,rom_c1.mem,rom_c1.drc);
	ppc.bind(0x0180,0x80,MAT_ROM,   0x0000ffff,&rom_c2,rom_c2.mem,rom_c2.drc);
//fix
	ppc.bind(0x8000,0x40,MAT_RAM,   0x0000ffff,&ram_b4,ram_b4.mem,ram_b4.drc);
	ppc.bind(0xf402,0x06,MAT_RAM,   0x0000ffff,&ram_d1,ram_d1.mem,ram_d1.drc);
	ppc.bind(0xf800,0x01,MAT_RAM,   0x0000ffff,&ram_d2,ram_d2.mem,ram_d2.drc);
	ppc.bind(0xfd00,0x08,MAT_DEVICE,0x0007ffff,&io,    NULL,      NULL      );
	ppc.bind(0xfe80,0x80,MAT_ROM,   0x0000ffff,&rom_p3,rom_p3.mem,rom_p3.drc);
	ppc.bind(0xff00,0x20,MAT_ROM,   0x0000ffff,&rom_p1,rom_p1.mem,rom_p1.drc);
	ppc.bind(0xffe0,0x20,MAT_ROM,   0x0000ffff,&rom_p1,rom_p1.mem,rom_p1.drc);
#else
	ppc.bind(0x0000,0x80,MAT_ROM,   0x0000ffff,&rom_p2,rom_p2.mem);
	ppc.bind(0x0080,0x80,MAT_ROM,   0x0000ffff,&rom_p3,rom_p3.mem);
	ppc.bind(0x9000,0x80,MAT_ROM,   0x0000ffff,&rom_c1,rom_c1.mem);
	ppc.bind(0x9080,0x80,MAT_ROM,   0x0000ffff,&rom_c2,rom_c2.mem);
//fix
	ppc.bind(0x8000,0x40,MAT_RAM,   0x0000ffff,&ram_b4,ram_b4.mem);
	ppc.bind(0xf400,0x01,MAT_DEVICE,0x000000ff,&kbg,   NULL      );
	ppc.bind(0xf402,0x06,MAT_RAM,   0x0000ffff,&ram_d1,ram_d1.mem);
	ppc.bind(0xf800,0x01,MAT_RAM,   0x0000ffff,&ram_d2,ram_d2.mem);
	ppc.bind(0xfd00,0x08,MAT_DEVICE,0x0007ffff,&io,    NULL      );
	ppc.bind(0xfe00,0x80,MAT_ROM,   0x0000ffff,&rom_p3,rom_p3.mem);
	ppc.bind(0xff00,0x20,MAT_ROM,   0x0000ffff,&rom_p1,rom_p1.mem);
	ppc.bind(0xffe0,0x20,MAT_ROM,   0x0000ffff,&rom_p1,rom_p1.mem);
#endif

	ppc.shadow();



/******************************************************************************
	MC68K
******************************************************************************/

	for(x=1;x!=0x10000;x++)		m68k.mat[x].type=NULL;

#ifdef	DYNAMIC_RECOMPILE
	m68k.bind(0x0000,0x08,MAT_RAM,0xffff,&ram_s1,ram_s1.mem,ram_s1.drc);
	m68k.bind(0x0010,0x01,MAT_RAM,0xffff,&ram_s2,ram_s2.mem,ram_s2.drc);
	m68k.bind(0x0020,0x01,MAT_RAM,0xffff,&ram_s3,ram_s3.mem,ram_s3.drc);
#else
	m68k.bind(0x0000,0x08,MAT_RAM,0xffff,&ram_s1,ram_s1.mem);
	m68k.bind(0x0010,0x01,MAT_RAM,0xffff,&ram_s2,ram_s2.mem);
	m68k.bind(0x0020,0x01,MAT_RAM,0xffff,&ram_s3,ram_s3.mem);
#endif

	m68k.shadow();
}
